;
         title  RSEdit Function Assistant
; ___________________________________________________
;|                                                   |
;|      RSEdit Function Library - Version 2.0.1      |
;|        -----------------------------------        |
;| pbrennick@verizon.net -- http://www.pbrennick.com |
;| ------------------------------------------------- |
;|                                                   |
;| Version key is as follows:                        |
;|           RSEdit Function Assistant a.b.c         |
;|           -------------------------------         |
;|                a:  a major change to the GUI      |
;|                b:  functions added and/or changed |
;|                c:  bug fixes                      |
;|                                                   |
;| Version History:                                  |
;| ----------------                                  |
;| 12Mar2004  Restructured the About Box and fixed a |
;|            bug in the About Box 'Close' function. |
;| 03Mar2004  Finalize the code in preparation of    |
;|            releasing it to Ramon.                 |
;| 02Mar2004  First public release of the software,  |
;|            to Ramon, of course.                   |
;| 01Mar2004  In a fit of pique, I removed all code  |
;|            from the DLL and trashed it in favor   |
;|            of all the code being integrated with  |
;|            the executable.                        |
;| 25Feb2004  The DLL I am using to serve the        |
;|            function table is giving me a bit of   |
;|            trouble on my XP box, it runs better   |
;|            on my '98SE box.  This could lead to   |
;|            future problems.                       |
;|___________________________________________________|
;|                                                   |
        .586      ; Maintain downwards compatibility |
        .model  flat, stdcall  ; 32 bit memory model |
        option  casemap:none   ; Case Sensitive == 1 |
;|___________________________________________________|
;
;       Included Files
;       ----------------------------------------;
        include \masm32\include\windows.inc     ; Index to additionally used Procedures
        include \masm32\include\user32.inc      ; Index to additionally used Procedures
        include \masm32\include\kernel32.inc    ; Index to additionally used Procedures
        include \masm32\macros\macros.asm       ; Index to additionally used Procedures
;
;       Included Libraries
;       ----------------------------------------;
        includelib \masm32\lib\user32.lib       ; Additionally used Procedures
        includelib \masm32\lib\kernel32.lib     ; Additionally used Procedures
;
; Local ProtoType Section
;---------------------------------------
ListBox         PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD     ; Internal Procedure
ListBoxProc     PROTO :DWORD,:DWORD,:DWORD,:DWORD   ; Internal Procedure
SpecialProc     PROTO :DWORD,:DWORD,:DWORD,:DWORD   ; Internal Procedure
TopXY           PROTO :DWORD,:DWORD                 ; Internal Procedure
WinMain         PROTO :DWORD,:DWORD,:DWORD,:DWORD   ; Internal Procedure
WndProc         PROTO :DWORD,:DWORD,:DWORD,:DWORD   ; Internal Procedure
;
; Macro Section
;---------------------------------------
szText  MACRO   Name, Text:VARARG
        LOCAL   lbl

        jmp     lbl
Name    db      Text, 0
lbl:
        ENDM
;
m2m     MACRO   M1, M2
        push    M2
        pop     M1
        ENDM
;
return  MACRO   arg
        mov     eax, arg
        ret
        ENDM
;
.data
;---------------------------------------
szDisplayName   db  "RSEdit Functions", 0
CommandLine     dd  0
hWnd            dd  0
hInstance       dd  0
hList           dd  0
lpListBox       dd  0
SpecialDLGName  db  'SpecialDLG', 0     ; Special Help/Information Dialog Box
SalaBlurb       db  "My name is Ramon Sala and  I", 39, "m catalan. Catalonia belongs politically "
                db  "to Spain, but we have our own government and language. When you enter my web page, "
                db  "catalan is the language it is written in, and there are two links (signaled with "
                db  "their respective flags) for english and spanish pages.  I like programming a lot, so "
                db  "that is what I do in my free time.  I hope you like and enjoy my applications "
                db  "(which are always free).", 0, 0
LineItem        db  "rsCreateEditor", 0
                db  "rsChangeControlColors", 0
                db  "rsCheckModified", 0
                db  "rsClearNextUndoEntry", 0
                db  "rsClearUndoBuffer", 0
                db  "rsCopyString", 0
                db  "rsDecrementUndoCount", 0
                db  "rsDisplayCursor", 0
                db  "rsExpandTabStops", 0
                db  "rsFindFirstChar", 0
                db  "rsFindHook", 0
                db  "rsFindNextWord", 0
                db  "rsFindPrevWord", 0
                db  "rsFindText", 0
                db  "rsGetLineAndExpandTabs", 0
                db  "rsGetLineFromChar", 0
                db  "rsGetLineIndex", 0
                db  "rsGetLineLength", 0
                db  "rsGetMemoryPosition", 0
                db  "rsGetNextLineIndex", 0
                db  "rsGetPrevLineIndex", 0
                db  "rsGetRealColWidth", 0
                db  "rsGetStringLength", 0
                db  "rsInitEditor", 0
                db  "rsInsertText", 0
                db  "rsIsAlpha", 0
                db  "rsIsAlphaNumeric", 0
                db  "rsLineScroll", 0
                db  "rsMakeSelectionVisible", 0
                db  "rsMoveMemory", 0
                db  "rsPaintControl", 0
                db  "rsProcessLButtonDown", 0
                db  "rsRedoAction", 0
                db  "rsReplaceSelection", 0
                db  "rsResizeTextBuffer", 0
                db  "rsSaveUndoBufer", 0
                db  "rsSaveUndoRedoText", 0
                db  "rsSearchCaseDown", 0
                db  "rsSearchCaseUp", 0
                db  "rsSearchNoCaseDown", 0
                db  "rsSearchNoCaseUp", 0
                db  "rsSearchText", 0
                db  "rsSelectWord", 0
                db  "rsSendNotifyMessage", 0
                db  "rsSetCaret", 0
                db  "rsSetFirstLineIndex", 0
                db  "rsStoreUndoText", 0
                db  "rsUndoAction ", 0
                db  0
rsCreateEditor  db  "Name:     rsCreateEditor", 13, 10
                db  "Function: Creates a new instance of the RS Edit control", 13, 10
                db  13, 10
                db  "Params:   hwndParent = Handle of the parent", 13, 10
                db  "          dwStyle    = Normal style (WS_CHILD, WS_VISIBLE, etc.)", 13, 10
                db  "          dwExStyle  = Extended style (WS_EX_CLIENTEDGE, etc.)", 13, 10
                db  "          lLeft      = X position (in pixels)", 13, 10
                db  "          lTop       = Y position (in pixels)", 13, 10
                db  "          lWidth     = Width (in pixels)", 13, 10
                db  "          lHeight    = Height (in pixels)", 13, 10
                db  13, 10
                db  "Returns: The handle of the new created control in EAX", 0
rsChangeControlColors  db  "Name:     rsChangeControlColors", 13, 10
                db  "Function: Changes one or more of the RS Edit control colors", 13, 10
                db  13, 10
                db  "Params:   lpEditData = Address of the RS Edit control's data structure", 13, 10
                db  "          lFlags     = Colors that must be changed", 13, 10
                db  13, 10
                db  "Bits meaning:     0 = 1 -> Changes the editor background", 13, 10
                db  "                  1 = 1 -> Changes the selection bar background", 13, 10
                db  "                  2 = 1 -> Changes the editor text color", 13, 10
                db  "                  3 = 1 -> Changes the editor selection background", 13, 10
                db  "                  4 = 1 -> Changes the editor selection text color", 0
rsCheckModified db  "Name:     rsCheckModified", 13, 10
                db  "Function: Checks if text is unmodified due to undo / redo operations", 13, 10
                db  13, 10
                db  "Params:   lpEditData = Address of the RS Edit control's data structure", 0
rsClearNextUndoEntry  db  "Name:     rsClearNextUndoEntry", 13, 10
                db  "Function: Clears the undo entry specified by the 'lpUndoCount' member of", 13, 10
                db  "          the RS Edit control's data structure", 13, 10
                db  13, 10
                db  "Params:   lpEditData = Address of the RS Edit control's data structure", 0
rsClearUndoBuffer  db  "Name:     rsClearUndoBuffer", 13, 10
                db  "Function: Clears the undo/redo buffer", 13, 10
                db  13, 10
                db  "Params:   lpEditData = Address of the RS Edit control's data structure", 0
rsCopyString    db  "Name:     rsCopyString", 13, 10
                db  "Function: Copies an ASCIIZ string into another", 13, 10
                db  13, 10
                db  "Params:  lpDest = Destination address of the copy", 13, 10
                db  "Params:  lpDest = Source address of the copy", 13, 10
                db  13, 10
                db  "Returns: The length of the copied string in EAX", 0
rsDecrementUndoCount  db  "Name:     rsDecrementUndoCount", 13, 10
                db  "Function: Decrements the undo / redo operations count", 13, 10
                db  13, 10
                db  "Params:   lpEditData = Address of the RS Edit control's data structure", 0
rsDisplayCursor db  "Name:     rsDisplayCursor", 13, 10
                db  "Function: Creates a caret and displays it on the screen", 13, 10
                db  13, 10
                db  "Params:   lpEditData = Address of the RS Edit control's data structure", 0
rsExpandTabStops db  "Name:     rsExpandTabStops", 13, 10
                db  "Function: Converts tabs to spaces", 13, 10
                db  13, 10
                db  "Params:   lpszLine   = Address ob buffer to store spaces", 13, 10
                db  "          lpLength   = Address of the current length of lpszLine", 13, 10
                db  13, 10
                db  "Remarks:  Ebx must point to the RS Edit control's data structure", 13, 10
                db  "          Edx must point to expanded tabs buffer (lpszLine+length)", 0
rsFindFirstChar db  "Name:     rsFindFirstChar", 13, 10
                db  "Function: Finds the first character not being a control character", 13, 10
                db  13, 10
                db  "Params:   lpEditData = Address of the RS Edit control's data structure", 13, 10
                db  13, 10
                db  "Returns: The zero based position of the character inside the line in EAX", 0
rsFindHook      db  "Name:     rsFindHook", 13, 10
                db  "Function: Called by 'rsIsAlpha' procedure. It can be subclassed by user", 13, 10
                db  "          to decide which characters are treated like a word break or not", 13, 10
                db  13, 10
                db  "Params:   chr = Character to be compared to", 13, 10
                db  13, 10
                db  "Returns:  TRUE  = Character is treated like part of word (no word-break)", 13, 10
                db  "          FALSE = Character is interpreted like a word-break", 0
rsFindNextWord  db  "Name:     rsFindNextWord", 13, 10
                db  "Function: Finds the next word after the cursor", 13, 10
                db  13, 10
                db  "Params:   lpEditData = Address of the RS Edit control's data structure", 13, 10
                db  "          lIndex     = Current character index (where the cursor is)", 13, 10
                db  13, 10
                db  "Returns: The character index of the next word in EAX", 0
rsFindPrevWord  db  "Name:     rsFindPrevWord", 13, 10
                db  "Function: Finds the previous word before the cursor", 13, 10
                db  13, 10
                db  "Params:   lpEditData = Address of the RS Edit control's data structure", 13, 10
                db  "          lIndex     = Current character index (where the cursor is)", 13, 10
                db  13, 10
                db  "Returns: The character index of the previous word in EAX", 0
rsFindText      db  "Name:     rsFindText", 13, 10
                db  "Function: Finds text according to an RSSFINDTEXT structure", 13, 10
                db  13, 10
                db  "Params:   lpEditData = Address of the RS Edit control's data structure", 13, 10
                db  "          lFlags     = Flags for searching", 13, 10
                db  "          rssFt      = Structure specifying what and how to search", 13, 10
                db  13, 10
                db  "Returns:  The character index of the text or -1 if not found in EAX", 0
rsGetLineAndExpandTabs  db  "Name:     rsGetLineAndExpandTabs", 13, 10
                db  "Function: Gets the line in the 'lpszLine' member buffer of the RS Edit", 13, 10
                db  "          control data structure, with expanded tabs, ready to be painted", 13, 10
                db  13, 10
                db  "Params:   lpEditData = Address of the RS Edit control's data structure", 13, 10
                db  "          lIndex     = Character index of the line to be retreived", 13, 10
                db  "          chr        = Address of a CHARSEL structure", 13, 10
                db  13, 10
                db  "Returns: The length of the expanded line in EAX", 0
rsGetLineFromChar  db  "Name:     rsGetLineFromChar", 13, 10
                db  "Function: Gets the zero based line number for the given index", 13, 10
                db  13, 10
                db  "Params:   lpEditData = Address of the RS Edit control's data structure", 13, 10
                db  "          lIndex     = Character index whose number is to be retreived", 13, 10
                db  "          bLineIndex = If TRUE, the new line index is stored in the", 13, 10
                db  "                       'lLineIndex' member of the data structure", 13, 10
                db  13, 10
                db  "Returns: The zero based line for the indicated index", 0
rsGetLineIndex  db  "Name:     rsGetLineIndex", 13, 10
                db  "Function: Gets the line index for the given line", 13, 10
                db  13, 10
                db  "Params:   lpEditData = Address of the RS Edit control's data structure", 13, 10
                db  "          lLine      = Line number whose line index is to be retreived", 13, 10
                db  13, 10
                db  "Returns: The line index for the indicated line", 0
rsGetLineLength db  "Name:     rsGetLineLength", 13, 10
                db  "Function: Gets the line length for the given index", 13, 10
                db  13, 10
                db  "Params:   lpEditData = Address of the RS Edit control's data structure", 13, 10
                db  "          lIndex     = Index of a char belonging to the line whose length", 13, 10
                db  "                       is to be retreived", 13, 10
                db  13, 10
                db  "Returns: The length of the line (including the carriage return) in EAX", 0
rsGetMemoryPosition  db  "Name:     rsGetMemoryPosition", 13, 10
                db  "Function: Gets the zero based position inside the line of the char stored", 13, 10
                db  "          in the 'ptPos.x' member (column) of the data structure", 13, 10
                db  13, 10
                db  "Params:   lpEditData = Address of the RS Edit control's data structure", 13, 10
                db  13, 10
                db  "Returns: The zero based position of the char in memory in EAX", 0
rsGetNextLineIndex  db  "Name:     rsGetNextLineIndex", 13, 10
                db  "Function: Gets the next line index (beginning of the next line)", 13, 10
                db  13, 10
                db  "Params:   lpEditData    = Address of the RS Edit control's data structure", 13, 10
                db  "          lCurrentIndex = Current line index (line index of current line)", 13, 10
                db  13, 10
                db  "Returns: The next line index in EAX", 0
rsGetPrevLineIndex  db  "Name:     rsGetPrevLineIndex", 13, 10
                db  "Function: Gets the previous line index (beginning of the previous line)", 13, 10
                db  13, 10
                db  "Params:   lpEditData    = Address of the RS Edit control's data structure", 13, 10
                db  "          lCurrentIndex = Current line index (line index of current line)", 13, 10
                db  13, 10
                db  "Returns: The previous line index in EAX", 0
rsGetRealColWidth  db  "Name:     rsGetRealColWidth", 13, 10
                db  "Function: Gets the real column width (with tabs expanded) in pixels", 13, 10
                db  13, 10
                db  "Returns: The length of the entire line in pixels", 0
rsGetStringLength  db  "Name:     rsGetStringLength", 13, 10
                db  "Function: Gets the length of an ASCIIZ string (saving Ecx and Edx)", 13, 10
                db  13, 10
                db  "Params:  lpszBuf = Address of the string whose length is to be retreived", 13, 10
                db  13, 10
                db  "Returns: The length of indicated string in EAX", 0
rsInitEditor    db  "Name:     rsInitEditor", 13, 10
                db  "Function: Initializes the RS Edit's data structure", 13, 10
                db  13, 10
                db  "Params:   lpEditData = Address of the RS Edit control's data structure", 13, 10
                db  "          lLength    = Length of the text in the editor or -1. If -1,", 13, 10
                db  "                       the length is unknown and has to be retreived", 0
rsInsertText    db  "Name:     rsInsertText", 13, 10
                db  "Function: Inserts text (or removes it) in the RS Edit control's memory", 13, 10
                db  13, 10
                db  "Params:   lpEditData = Address of the RS Edit control's data structure", 13, 10
                db  "          lpszChar   = Addres of text to be inserted", 13, 10
                db  13, 10
                db  "Returns:  The length of the inserted text", 0
rsIsAlpha       db  "Name:     rsIsAlpha", 13, 10
                db  "Function: Specifies whether a character is a letter or not", 13, 10
                db  13, 10
                db  "Params:   chr        = Character to check", 13, 10
                db  "          prFindProc = Address of the FindProc function", 13, 10
                db  13, 10
                db  "Returns:  TRUE if chr is an alpha character, FALSE if not", 0
rsIsAlphaNumeric db  "Name:     rsIsAlphaNumeric", 13, 10
                db  "Function: Specifies whether a character is alphanumeric or not", 13, 10
                db  13, 10
                db  "Params:   chr        = Character to check", 13, 10
                db  "          prFindProc = Address of the FindProc function", 13, 10
                db  13, 10
                db  "Returns:  TRUE if chr is a letter or o number, FALSE if not", 0
rsLineScroll    db  "Name:     rsLineScroll", 13, 10
                db  "Function: Scrolls controls' text the specified number of columns/lines", 13, 10
                db  13, 10
                db  "Params:   lpEditData = Address of the RS Edit control's data structure", 13, 10
                db  "          lCols      = Number of columns to be scrolled", 13, 10
                db  "          lLines     = Number of lines to be scrolled", 13, 10
                db  13, 10
                db  "Returns:  Nothing", 13, 10
                db  13, 10
                db  "Remarks:  To scroll to left or top, specify negative values", 0
rsMakeSelectionVisible  db  "Name:     rsMakeSelectionVisible", 13, 10
                db  "Function: Sets the best line index for the first visible line, in order", 13, 10
                db  "          to center the word in the indexes indicated by 'lStart - lEnd'", 13, 10
                db  13, 10
                db  "Params:   lpEditData = Address of the RS Edit control's data structure", 13, 10
                db  "          lPos       = Character index to check for", 13, 10
                db  13, 10
                db  "Returns:  Nothing", 0
rsMoveMemory    db  "Name:     rsMoveMemory", 13, 10
                db  "Function: Moves 'lCount' bytes from 'lpszSource' to 'lpszDest'", 13, 10
                db  13, 10
                db  "Params:   lpszSource = Address of the source of data to be moved", 13, 10
                db  "          lpszDest   = Address of the destination where to move to", 13, 10
                db  "          lCount     = Number of bytes to be moved", 13, 10
                db  13, 10
                db  "Returns:  Nothing", 0
rsPaintControl  db  "Name:     rsPaintControl", 13, 10
                db  "Function: Paints the entire RS Edit control (processes WM_PAINT)", 13, 10
                db  13, 10
                db  "Params:   lpEditData = Address of the control's data", 13, 10
                db  13, 10
                db  "Returns:  Nothing", 13, 10
                db  13, 10
                db  "Remarks:  If an address for a 'Paint proc' has been set (refer to message", 13, 10
                db  "          RSM_SETPAINTPROC) RSEdit gives control to that procedure and", 13, 10
                db  "          does not paint anything.", 0
rsProcessLButtonDown  db  "Name:     rsProcessLButtonDown", 13, 10
                db  "Function: Processes WM_LBUTTONDOWN message", 13, 10
                db  13, 10
                db  "Params:   lpEditData  = Address of the RS Edit control's data structure", 13, 10
                db  "          wMsg        = Value of uMsg parameter", 13, 10
                db  "          wParam      = Value of wParam parameter", 13, 10
                db  "          lParam      = Value of lParam parameter", 13, 10
                db  13, 10
                db  "Returns:  The character index where the mouse clicked", 0
rsRedoAction    db  "Name:     rsRedoAction", 13, 10
                db  "Function: Performs a redo action (if any)", 13, 10
                db  13, 10
                db  "Params:   lpEditData = Address of the RS Edit control's data structure", 13, 10
                db  13, 10
                db  "Returns:  Nothing", 0
rsReplaceSelection  db  "Name:     rsReplaceSelection", 13, 10
                db  "Function: Replaces selected text with text specified by lpszChar", 13, 10
                db  13, 10
                db  "Params:   lpEditData = Address of the RS Edit control's data structure", 13, 10
                db  "          lpszChar   = Address of new text", 13, 10
                db  "          lKey       = Key code for undo action (-1 if no undo)", 13, 10
                db  13, 10
                db  "Returns:  Nothing", 13, 10
                db  13, 10
                db  "Remarks:  If there is no text selected, the new text is inserted in the", 13, 10
                db  "          caret's position (the insertion point)", 0
rsResizeTextBuffer  db  "Name:     rsResizeTextBuffer", 13, 10
                db  "Function: Resizes text buffer to fit the new text length", 13, 10
                db  13, 10
                db  "Params:   lpEditData = Address of the RS Edit control's data structure", 13, 10
                db  "          lBytes     = Number of bytes to be add", 13, 10
                db  13, 10
                db  "Returns:  Nothing", 0
rsSaveUndoBufer db  "Name:     rsSaveUndoBufer", 13, 10
                db  "Function: Saves the undo buffer contents (one key strokes)", 13, 10
                db  13, 10
                db  "Params:   lpEditData = Address of the RS Edit control's data structure", 13, 10
                db  13, 10
                db  "Returns:  Nothing", 0
rsSaveUndoRedoText  db  "Name:     rsSaveUndoRedoText", 13, 10
                db  "Function: Saves blocks of text for undo / redo operations", 13, 10
                db  13, 10
                db  "Params:   lpEditData = Address of the RS Edit control's data structure", 13, 10
                db  "          szNewText  = Address of new text", 13, 10
                db  13, 10
                db  "Returns:  Nothing", 0
rsSearchCaseDown  db  "Name:     rsSearchCaseDown", 13, 10
                db  "Function: Searches text down (case sensitive) from a specified position", 13, 10
                db  13, 10
                db  "Params:   lpText   = Buffer containing text to search for", 13, 10
                db  "          lpSearch = Address for buffer where to start searching", 13, 10
                db  "          lPointer = Address of the first char in controls' text buffer", 13, 10
                db  13, 10
                db  "Returns:  The character index of the text or -1 if not found in Eax", 0
rsSearchCaseUp  db  "Name:     rsSearchCaseUp", 13, 10
                db  "Function: Searches text up (case sensitive) from a specified position", 13, 10
                db  13, 10
                db  "Params:   lpText   = Buffer containing text to search for", 13, 10
                db  "          lpSearch = Address for buffer where to start searching", 13, 10
                db  "          lPointer = Address of the first char in controls' text buffer", 13, 10
                db  13, 10
                db  "Returns:  The character index of the text or -1 if not found in EAX", 0
rsSearchNoCaseDown  db  "Name:     rsSearchNoCaseDown", 13, 10
                db  "Function: Searches text down (case insensitive) from a specified position", 13, 10
                db  13, 10
                db  "Params:   lpText   = Buffer containing text to search for", 13, 10
                db  "          lpSearch = Address for buffer where to start searching", 13, 10
                db  "          lPointer = Address of the first char in controls' text buffer", 13, 10
                db  13, 10
                db  "Returns:  The character index of the text or -1 if not found in EAX", 0
rsSearchNoCaseUp db  "Name:     rsSearchNoCaseUp", 13, 10
                db  "Function: Searches text up (case insensitive) from a specified position", 13, 10
                db  13, 10
                db  "Params:   lpText   = Buffer containing text to search for", 13, 10
                db  "          lpSearch = Address for buffer where to start searching", 13, 10
                db  "          lPointer = Address of the first char in controls' text buffer", 13, 10
                db  13, 10
                db  "Returns:  The character index of the text or -1 if not found in EAX", 0
rsSearchText    db "Name:     rsSearchText", 13, 10
                db  "Function: Searches text according to flags and RSSFINDTEXT structure", 13, 10
                db  13, 10
                db  "Params:   lpText   = Buffer containing text to search for", 13, 10
                db  "          lFlags   = Flags indicating how to search text", 13, 10
                db  "          lPointer = Address of the first char in controls' text buffer", 13, 10
                db  "          lpSearch = Address for buffer where to start searching", 13, 10
                db  13, 10
                db  "Returns:  The character index of the text or -1 if not found in EAX", 0
rsSelectWord    db  "Name:     rsSelectWord", 13, 10
                db  "Function: Fills the 'chrPos' member of the edit data structure with the", 13, 10
                db  "          character indexes of the word which is in the position specified", 13, 10
                db  "          by 'lPos' parameter. If there is no word, it fills the 'chrPos'", 13, 10
                db  "          member with the value specified by 'lPos' parameter.", 13, 10
                db  13, 10
                db  "Params:   lpEditData = Address of the RS Edit control's data structure", 13, 10
                db  "          lPos       = Character index of any part of the text", 13, 10
                db  "          bSpaces    = Specifies whether spaces and tabs (blanks) will be", 13, 10
                db  "                     = taken into account (TRUE = Yes).", 13, 10
                db  13, 10
                db  "Returns:  Nothing", 0
rsSendNotifyMessage  db  "Name:     rsSendNotifyMessage", 13, 10
                db  "Function: Sends a WM_NOTIFY message to the parent window", 13, 10
                db  13, 10
                db  "Params:   lpEditData = Address of the RS Edit control's data structure", 13, 10
                db  "          uCode      = The code of the message (NM_CLICK, NM_DBLCLK, etc.)", 13, 10
                db  13, 10
                db  "Returns:  Nothing", 0
rsSetCaret      db  "Name:     rsSetCaret", 13, 10
                db  "Function: Positions the caret in the x, y coordinates (specified by the", 13, 10
                db  "          members 'ptPos.x' and 'ptPos.y' of the data structure)", 13, 10
                db  13, 10
                db  "Params:   lpEditData = Address of the RS Edit control's data structure", 13, 10
                db  13, 10
                db  "Returns:  Nothing", 0
rsSetFirstLineIndex  db  "Name:     rsSetFirstLineIndex", 13, 10
                db  "Function: Sets the line index for the first visible line", 13, 10
                db  13, 10
                db  "Params:   lpEditData = Address of the RS Edit control's data structure", 13, 10
                db  13, 10
                db  "Returns:  Nothing", 0
rsStoreUndoText db  "Name:     rsStoreUndoText", 13, 10
                db  "Function: Stores modified text for undo operations", 13, 10
                db  13, 10
                db  "Params:   lpEditData = Address of the RS Edit control's data structure", 13, 10
                db  13, 10
                db  "Retuns:   Nothing", 0
rsUndoAction    db  "Name:     rsUndoAction", 13, 10
                db  "Function: Performs an undo action (if any)", 13, 10
                db  13, 10
                db  "Params:   lpEditData = Address of the RS Edit control's data structure", 13, 10
                db  13, 10
                db  "Returns:  Nothing", 0
                db  0
;
.data?
;---------------------------------------
ItemBuffer      db  128 dup (?)
hMenu           dd  ?
hfMnu           dd  ?
hhMnu           dd  ?
hIcon           dd  ?                   ; Handle
;
.const
;---------------------------------------
IDC_OK          equ 123                 ; 'Okay' Pushbutton
;
;
.code
;---------------------------------------
start:  invoke  GetModuleHandle, NULL
        mov     hInstance, eax
        invoke  GetCommandLine
        mov     CommandLine, eax
        invoke  WinMain, hInstance, NULL, CommandLine, SW_SHOWDEFAULT
        invoke  ExitProcess, eax
;
;
WinMain proc    hInst:DWORD, hPrevInst:DWORD, CmdLine:DWORD, CmdShow:DWORD
;---------------------------------------
        LOCAL   wc:WNDCLASSEX
        LOCAL   msg:MSG
        LOCAL   Wwd:DWORD
        LOCAL   Wht:DWORD
        LOCAL   Wtx:DWORD
        LOCAL   Wty:DWORD
;        _________________________________________________
;       |                                                 |
;       | Fill WNDCLASSEX Structure With Needed Variables |
;       |_________________________________________________|
;
        mov     wc.cbSize,         sizeof WNDCLASSEX
        mov     wc.style,          CS_HREDRAW or CS_VREDRAW \
                                   or CS_BYTEALIGNWINDOW
        mov     wc.lpfnWndProc,    offset WndProc
        mov     wc.cbClsExtra,     NULL
        mov     wc.cbWndExtra,     NULL
        m2m     wc.hInstance,      hInst            ; << NOTE: macro not mnemonic
        mov     wc.hbrBackground,  COLOR_BTNFACE+1
        mov     wc.lpszMenuName,   NULL
        mov     wc.lpszClassName,  offset szClassName
        invoke  LoadIcon, hInst,   500              ; Icon ID
        mov     wc.hIcon,          eax
        invoke  LoadCursor,NULL,   IDC_ARROW
        mov     wc.hCursor,        eax
        mov     wc.hIconSm,        0
        invoke  RegisterClassEx,   ADDR wc
;        _____________________________________
;       |                                     |
;       | Centre window at the following size |
;       |_____________________________________|
;
        mov     Wwd, 235
        mov     Wht, 275
        invoke  GetSystemMetrics, SM_CXSCREEN
        invoke  TopXY, Wwd, eax
        mov     Wtx, eax
        invoke  GetSystemMetrics, SM_CYSCREEN
        invoke  TopXY, Wht, eax
        mov     Wty, eax
        szText  szClassName,    "Template_Class"
        invoke  CreateWindowEx, WS_EX_PALETTEWINDOW or WS_EX_CLIENTEDGE,
                                ADDR szClassName, ADDR szDisplayName,
                                WS_OVERLAPPEDWINDOW or LBS_HASSTRINGS or \
                                LBS_NOINTEGRALHEIGHT or LBS_DISABLENOSCROLL, \
                                Wtx, Wty, Wwd, Wht, NULL, NULL, hInst, NULL
        mov     hWnd, eax
        mov     hMenu, FUNC(CreateMenu)     ; Main Menu
        mov     hfMnu, FUNC(CreateMenu)     ; File Menu
        mov     hhMnu, FUNC(CreateMenu)     ; Help Menu
;
;       File Menu
        invoke  AppendMenu, hMenu, MF_POPUP, hfMnu, chr$("&File")
        invoke  AppendMenu, hfMnu, MF_STRING, 1000, chr$("&Exit", 9, "Alt+F4")
;
;       Help Menu
        invoke  AppendMenu, hMenu, MF_POPUP, hhMnu, chr$("&Help")
        invoke  AppendMenu, hhMnu, MF_STRING, 1900, chr$("&About")
;
        invoke  SetMenu, hWnd, hMenu
        invoke  ShowWindow, hWnd, SW_SHOWNORMAL
        invoke  UpdateWindow, hWnd
;        _______________________________________
;       |                                       |
;       | Loop until the PostQuitMessage is sent|
;       |_______________________________________|
;
StartLoop:
        invoke  GetMessage, ADDR msg, NULL, 0, 0
        cmp     eax, 0
        je      ExitLoop
        invoke  TranslateMessage, ADDR msg
        invoke  DispatchMessage, ADDR msg
        jmp     StartLoop
ExitLoop:
        return  msg.wParam
;---------------------------------------
WinMain endp
;
;
WndProc proc Uses Edi Esi hWin:DWORD, uMsg:DWORD, wParam:DWORD, lParam:DWORD
;---------------------------------------
;       Menu Commands
        .if uMsg == WM_COMMAND
          .if wParam == 1000
            invoke  SendMessage, hWin, WM_SYSCOMMAND, SC_CLOSE, NULL
          .elseif wParam == 1900
            invoke  DialogBoxParam, hInstance, ADDR SpecialDLGName, 0, ADDR SpecialProc, 0 ; Show Information Dialog Box
          .endif
;         Menu Commands End
        .elseif uMsg == WM_CREATE
          invoke  ListBox, 12, 14, 200, 200, hWin, 500
          mov     hList, eax
          invoke  SetWindowLong, hList, GWL_WNDPROC, ListBoxProc
          mov     lpListBox, eax
;          _____________________________________________________
;         |                                                     |
;         | This block of code reads a string that is a list of |
;         | separate items delimited by a single zero byte. The |
;         | list is terminated by a double zero byte pair.      |
;         |_____________________________________________________|
;
          mov     esi, offset LineItem
          mov     edi, offset ItemBuffer
@@:       lodsb
          cmp     al, 0                 ; Test for terminator
          je      Build                 ; Write to list
          stosb
          jmp     @B
Build:    stosb                         ; Write terminator
          invoke  SendMessage, hList, LB_ADDSTRING, 0, ADDR ItemBuffer
          lodsb
          cmp     al, 0                 ; Check for second zero
          je      @F                    ; Exit if found
          mov     edi, offset ItemBuffer  ; Reset to start of buffer
          stosb                         ; Write test byte to it
          jmp     @B
@@:     .elseif uMsg == WM_CLOSE
          szText  TheText, "Please Confirm Exit"
          invoke  MessageBox, hWin, ADDR TheText, ADDR szDisplayName, MB_YESNO
          .if eax == IDNO
            return  0
          .endif
        .elseif uMsg == WM_DESTROY
          invoke  PostQuitMessage, NULL
          return  0 
        .endif
        invoke  DefWindowProc, hWin, uMsg, wParam, lParam
        ret
;---------------------------------------
WndProc endp
;
;
TopXY   proc    wDim:DWORD, sDim:DWORD
;---------------------------------------;
        shr     sDim, 1                 ; Divide screen dimension by 2
        shr     wDim, 1                 ; Divide window dimension by 2
        mov     eax, wDim               ; Copy window dimension into eax
        sub     sDim, eax               ; Sub half win dimension from half screen dimension
        return  sDim                    ;
;---------------------------------------;
TopXY   endp
;
;
ListBox proc    a:DWORD, b:DWORD, wd:DWORD, ht:DWORD, hParent:DWORD, ID:DWORD
;---------------------------------------
        szText  lstBox, "LISTBOX"
        invoke  CreateWindowEx, WS_EX_CLIENTEDGE, ADDR lstBox, 0,
                WS_VSCROLL or WS_VISIBLE or WS_BORDER or WS_CHILD or \
                LBS_HASSTRINGS or LBS_NOINTEGRALHEIGHT or \
                LBS_DISABLENOSCROLL, a, b, wd, ht, hParent, ID, hInstance, NULL
        ret
;---------------------------------------
ListBox endp
;
;
ListBoxProc proc Uses Esi hCtl:DWORD, uMsg:DWORD, wParam:DWORD, lParam:DWORD
;---------------------------------------
        LOCAL   IndexItem:DWORD
        LOCAL   Buffer[32]:BYTE
;
        .if uMsg == WM_LBUTTONDBLCLK
          jmp     DoIt
        .elseif uMsg == WM_CHAR
          .if wParam == 13
            jmp DoIt
          .endif
        .endif
        jmp     EndDo
DoIt:   invoke  SendMessage, hCtl, LB_GETCURSEL, 0, 0
        mov     IndexItem, eax
        invoke  SendMessage, hCtl, LB_GETTEXT, IndexItem, ADDR Buffer
        mov     eax, hList
        .if hCtl == eax
          lea     esi, rsCreateEditor
          invoke  lstrcmp, ADDR Buffer, chr$("rsCreateEditor")
          cmp     eax, 0
          je      found
          lea     esi, rsChangeControlColors
          invoke  lstrcmp, ADDR Buffer, chr$("rsChangeControlColors")
          cmp     eax, 0
          je      found
          lea     esi, rsCheckModified
          invoke  lstrcmp, ADDR Buffer, chr$("rsCheckModified")
          cmp     eax, 0
          je      found
          lea     esi, rsClearNextUndoEntry
          invoke  lstrcmp, ADDR Buffer, chr$("rsClearNextUndoEntry")
          cmp     eax, 0
          je      found
          lea     esi, rsClearUndoBuffer
          invoke  lstrcmp, ADDR Buffer, chr$("rsClearUndoBuffer")
          cmp     eax, 0
          je      found
          lea     esi, rsCopyString
          invoke  lstrcmp, ADDR Buffer, chr$("rsCopyString")
          cmp     eax, 0
          je      found
          lea     esi, rsDecrementUndoCount
          invoke  lstrcmp, ADDR Buffer, chr$("rsDecrementUndoCount")
          cmp     eax, 0
          je      found
          lea     esi, rsDisplayCursor
          invoke  lstrcmp, ADDR Buffer, chr$("rsDisplayCursor")
          cmp     eax, 0
          je      found
          lea     esi, rsExpandTabStops
          invoke  lstrcmp, ADDR Buffer, chr$("rsExpandTabStops")
          cmp     eax, 0
          je      found
          lea     esi, rsFindFirstChar
          invoke  lstrcmp, ADDR Buffer, chr$("rsFindFirstChar")
          cmp     eax, 0
          je      found
          lea     esi, rsFindHook
          invoke  lstrcmp, ADDR Buffer, chr$("rsFindHook")
          cmp     eax, 0
          je      found
          lea     esi, rsFindNextWord
          invoke  lstrcmp, ADDR Buffer, chr$("rsFindNextWord")
          cmp     eax, 0
          je      found
          lea     esi, rsFindPrevWord
          invoke  lstrcmp, ADDR Buffer, chr$("rsFindPrevWord")
          cmp     eax, 0
          je      found
          lea     esi, rsFindText
          invoke  lstrcmp, ADDR Buffer, chr$("rsFindText")
          cmp     eax, 0
          je      found
          lea     esi, rsGetLineAndExpandTabs
          invoke  lstrcmp, ADDR Buffer, chr$("rsGetLineAndExpandTabs")
          cmp     eax, 0
          je      found
          lea     esi, rsGetLineFromChar
          invoke  lstrcmp, ADDR Buffer, chr$("rsGetLineFromChar")
          cmp     eax, 0
          je      found
          lea     esi, rsGetLineIndex
          invoke  lstrcmp, ADDR Buffer, chr$("rsGetLineIndex")
          cmp     eax, 0
          je      found
          lea     esi, rsGetLineLength
          invoke  lstrcmp, ADDR Buffer, chr$("rsGetLineLength")
          cmp     eax, 0
          je      found
          lea     esi, rsGetMemoryPosition
          invoke  lstrcmp, ADDR Buffer, chr$("rsGetMemoryPosition")
          cmp     eax, 0
          je      found
          lea     esi, rsGetNextLineIndex
          invoke  lstrcmp, ADDR Buffer, chr$("rsGetNextLineIndex")
          cmp     eax, 0
          je      found
          lea     esi, rsGetPrevLineIndex
          invoke  lstrcmp, ADDR Buffer, chr$("rsGetPrevLineIndex")
          cmp     eax, 0
          je      found
          lea     esi, rsGetRealColWidth
          invoke  lstrcmp, ADDR Buffer, chr$("rsGetRealColWidth")
          cmp     eax, 0
          je      found
          lea     esi, rsGetStringLength
          invoke  lstrcmp, ADDR Buffer, chr$("rsGetStringLength")
          cmp     eax, 0
          je      found
          lea     esi, rsInitEditor
          invoke  lstrcmp, ADDR Buffer, chr$("rsInitEditor")
          cmp     eax, 0
          je      found
          lea     esi, rsInsertText
          invoke  lstrcmp, ADDR Buffer, chr$("rsInsertText")
          cmp     eax, 0
          je      found
          lea     esi, rsIsAlpha
          invoke  lstrcmp, ADDR Buffer, chr$("rsIsAlpha")
          cmp     eax, 0
          je      found
          lea     esi, rsIsAlphaNumeric
          invoke  lstrcmp, ADDR Buffer, chr$("rsIsAlphaNumeric")
          cmp     eax, 0
          je      found
          lea     esi, rsLineScroll
          invoke  lstrcmp, ADDR Buffer, chr$("rsLineScroll")
          cmp     eax, 0
          je      found
          lea     esi, rsMakeSelectionVisible
          invoke  lstrcmp, ADDR Buffer, chr$("rsMakeSelectionVisible")
          cmp     eax, 0
          je      found
          lea     esi, rsMoveMemory
          invoke  lstrcmp, ADDR Buffer, chr$("rsMoveMemory")
          cmp     eax, 0
          je      found
          lea     esi, rsPaintControl
          invoke  lstrcmp, ADDR Buffer, chr$("rsPaintControl")
          cmp     eax, 0
          je      found
          lea     esi, rsProcessLButtonDown
          invoke  lstrcmp, ADDR Buffer, chr$("rsProcessLButtonDown")
          cmp     eax, 0
          je      found
          lea     esi, rsRedoAction
          invoke  lstrcmp, ADDR Buffer, chr$("rsRedoAction")
          cmp     eax, 0
          je      found
          lea     esi, rsReplaceSelection
          invoke  lstrcmp, ADDR Buffer, chr$("rsReplaceSelection")
          cmp     eax, 0
          je      found
          lea     esi, rsResizeTextBuffer
          invoke  lstrcmp, ADDR Buffer, chr$("rsResizeTextBuffer")
          cmp     eax, 0
          je      found
          lea     esi, rsSaveUndoBufer
          invoke  lstrcmp, ADDR Buffer, chr$("rsSaveUndoBufer")
          cmp     eax, 0
          je      found
          lea     esi, rsSaveUndoRedoText
          invoke  lstrcmp, ADDR Buffer, chr$("rsSaveUndoRedoText")
          cmp     eax, 0
          je      found
          lea     esi, rsSearchCaseDown
          invoke  lstrcmp, ADDR Buffer, chr$("rsSearchCaseDown")
          cmp     eax, 0
          je      found
          lea     esi, rsSearchCaseUp
          invoke  lstrcmp, ADDR Buffer, chr$("rsSearchCaseUp")
          cmp     eax, 0
          je      found
          lea     esi, rsSearchNoCaseDown
          invoke  lstrcmp, ADDR Buffer, chr$("rsSearchNoCaseDown")
          cmp     eax, 0
          je      found
          lea     esi, rsSearchNoCaseUp
          invoke  lstrcmp, ADDR Buffer, chr$("rsSearchNoCaseUp")
          cmp     eax, 0
          je      found
          lea     esi, rsSearchText
          invoke  lstrcmp, ADDR Buffer, chr$("rsSearchText")
          cmp     eax, 0
          je      found
          lea     esi, rsSelectWord
          invoke  lstrcmp, ADDR Buffer, chr$("rsSelectWord")
          cmp     eax, 0
          je      found
          lea     esi, rsSendNotifyMessage
          invoke  lstrcmp, ADDR Buffer, chr$("rsSendNotifyMessage")
          cmp     eax, 0
          je      found
          lea     esi, rsSetCaret
          invoke  lstrcmp, ADDR Buffer, chr$("rsSetCaret")
          cmp     eax, 0
          je      found
          lea     esi, rsSetFirstLineIndex
          invoke  lstrcmp, ADDR Buffer, chr$("rsSetFirstLineIndex")
          cmp     eax, 0
          je      found
          lea     esi, rsStoreUndoText
          invoke  lstrcmp, ADDR Buffer, chr$("rsStoreUndoText")
          cmp     eax, 0
          je      found
          lea     esi, rsUndoAction
found:    invoke  MessageBox, hWnd, esi, ADDR Buffer, MB_OK
        .endif
EndDo:  invoke  CallWindowProc, lpListBox, hCtl, uMsg, wParam, lParam
        ret
;---------------------------------------
ListBoxProc endp
;
;
SpecialProc proc hwnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM
;---------------------------------------
        .if uMsg == WM_INITDIALOG       ; If 'Initialize Dialog' request...
          invoke  SetDlgItemText, hwnd, 300, addr SalaBlurb   ; Show the text message
          ret                           ; Return  to caller
        .elseif uMsg==WM_COMMAND
          mov eax, wParam               ; Get the command
          .if eax == 200
            invoke  EndDialog, hwnd, 0
          .endif
        .elseif uMsg==WM_CLOSE
          invoke  EndDialog, hwnd, 0
        .else
          mov     eax, FALSE
          ret
        .endif
        mov     eax, TRUE
        ret
;---------------------------------------
SpecialProc endp
;
;
        end     start

